 
  
varying vec3 Position;
varying vec3  Normal;


void directionalLight0(
    in    vec3 normal,
    inout vec4 ambient,
    inout vec4 diffuse,
    inout vec4 specular,
    in float zdir)
{
 
    // Normalized light direction and half vector
    vec3 thePosition=vec3(gl_LightSource[0].position);
    thePosition.x*=zdir;
    thePosition.y*=zdir;
     thePosition.z*=zdir;
    vec3 lightDirection = normalize(vec3(thePosition));
    
    vec3 halfVector =  vec3(gl_LightSource[0].halfVector);
    halfVector.x*=zdir;
    halfVector.y*=zdir;
    halfVector.z*=zdir;
    halfVector = normalize(halfVector);
    
    float nDotVP; // normal . light_direction
    float nDotHV; // normal . light_half_vector
    float pf; // power factor

    nDotVP = max(0.0, dot(normal, lightDirection));
    nDotHV = max(0.0, dot(normal, halfVector));

    if (nDotVP == 0.0) {
	pf = 0.0;
    }
    else {
	pf = pow(nDotHV, gl_FrontMaterial.shininess);
    }

    ambient += gl_LightSource[0].ambient;
    diffuse += gl_LightSource[0].diffuse * nDotVP;
    specular += gl_LightSource[0].specular * pf;
}




void main (void)
{

    vec3 unitNorm = normalize(Normal);
    vec4 amb =  vec4(0.0);
    vec4 diff =  vec4(0.0);
    vec4 spec =  vec4(0.0);
    int i;
 // grainsize shader
//  der Algorithmus geht von 3D-verteilten Kugeln aus
//  die Flaechennormale wird ueber die Kugeloberflaeche berechnet
//  mit der Scalierung wird der Korndurchesser bestimmt

// berechnen der normal in abhaengigkeit von der Position zur Kugel

float scale=0.1;  // legt die Scalierung fest, wird ueber eine uniform Variable uebergebeb
float grainsize=0.5;
float exageration=1.;

// berechnen der Position zur Kugel
vec3 center=Position;
  center.x=(fract(Position.x/scale)-0.5);
  center.y=(fract(Position.y/scale)-0.5);
  center.z=(fract((Position.z*exageration)/scale)-0.5);

    float length=sqrt(center.x*center.x+center.y*center.y+center.z*center.z);

 

// abtesten auf radius   

 
float intensity=1.;
if (length < grainsize){
 //discard;

  center=normalize(center);
     
  // intensity*=(1-length)*1.3;
} else {
  center=unitNorm;
} 
 
    directionalLight0(center,  amb, diff, spec,1.);
   directionalLight0(center,  amb, diff, spec,-1.);
    
    vec4 secondaryColor = vec4(vec3(spec * gl_FrontMaterial.specular), 1.0);

    vec4 color2 = vec4(vec3( 
		       amb * gl_FrontMaterial.ambient*intensity +
		       diff * gl_FrontMaterial.diffuse)*intensity,1.0);

     // color2+=secondaryColor;
  color2.w=gl_FrontMaterial.diffuse.w;
  
      gl_FragColor =color2;
}

