 
varying vec3 Position;
varying vec3  Normal;
varying vec3 realNormal;  
varying vec2 TexCoord; 

 
uniform sampler2D theTex;
 

uniform float exageration; 
uniform float swapYZ;
uniform float texScale; 


void directionalLight0(
    in    vec3 normal,
    inout vec4 ambient,
    inout vec4 diffuse,
    inout vec4 specular,
    in float zdir)
{
 
    // Normalized light direction and half vector
     vec3 thePosition=vec3(gl_LightSource[0].position);
    thePosition.x*=zdir;
    thePosition.y*=zdir;
     thePosition.z*=zdir;
    vec3 lightDirection = normalize(vec3(thePosition));
    
    vec3 halfVector =  vec3(gl_LightSource[0].halfVector);
    halfVector.x*=zdir;
    halfVector.y*=zdir;
    halfVector.z*=zdir;
    halfVector = normalize(halfVector);
    
    float nDotVP; // normal . light_direction
    float nDotHV; // normal . light_half_vector
    float pf; // power factor

    nDotVP = max(0.0, dot(normal, lightDirection));
    nDotHV = max(0.0, dot(normal, halfVector));

    if (nDotVP == 0.0) {
	pf = 0.0;
    }
    else {
	pf = pow(nDotHV, gl_FrontMaterial.shininess);
    }

    ambient += gl_LightSource[0].ambient;
    diffuse += gl_LightSource[0].diffuse * nDotVP;
    specular += gl_LightSource[0].specular * pf;
}




void main (void)
{
    float tScale=texScale;
    if (tScale < 1.) tScale=1.;
    float textureScale=5000.*tScale/100.;
    vec2 tc;
    vec3 unitNorm = normalize(Normal);
    vec4 amb =  vec4(0.0);
    vec4 diff =  vec4(0.0);
    vec4 spec =  vec4(0.0);
    
 
    
    directionalLight0(unitNorm,  amb, diff, spec,1.);
    directionalLight0(unitNorm,  amb, diff, spec,-1.);
    
   
if (swapYZ == 0.) {
    tc.x=(Position.x / textureScale);
    tc.y=(Position.y / textureScale);

 
// Spiegeln der Textur
     if (fract( floor(tc.x)/2. )!= 0. ) {
       
       tc.x=1.-fract(tc.x);
       
     } else tc.x=fract(tc.x);
     
      if (fract(floor(tc.y)/2.)!= 0. ) {
       
       tc.y=1.-fract(tc.y);
       
     } else tc.y=fract(tc.y);
     
     
} else  {
   //tc.x=(sqrt(Position.x*Position.x+Position.y*Position.y) / textureScale);
   
   // tc.x=(Position.x*realNormal.y +Position.y*realNormal.x ) / textureScale;
     tc.x=TexCoord.s / textureScale;
     
     tc.y=(Position.z*exageration) / textureScale;
   
    if (fract( floor(tc.x)/2. )!= 0. ) {
       
       tc.x=1.-fract(tc.x);
       
     } else tc.x=fract(tc.x);
     
   
    if (fract(floor(tc.y)/2.)!= 0. ) {
       
       tc.y=1.-fract(tc.y);
       
     } else tc.y=fract(tc.y);
     
     

}

 
     vec4 envColor=vec4(texture2D(theTex,tc));
     
 
    

 // vec4 secondaryColor = vec4(vec3(spec * envColor), 1.0)*0.333;
   
   //if ((envColor.x > 0.9) && (envColor.y > 0.9) && (envColor.z > 0.9)) envColor=gl_FrontMaterial.diffuse;
   
   vec4 color2 = vec4(vec3(diff * envColor +
		       amb * envColor +
		       diff * envColor),1.0);
		       
    // color2+=secondaryColor;
     
     
     
     // Holen des Alpha-Wertes fuer die Transparenz
     color2.w=gl_FrontMaterial.diffuse.w;
    
      
 
      gl_FragColor =color2;
}
