 
 
varying vec3  Normal;
  
uniform sampler2D theTex;
 


void directionalLight0(
    in    vec3 normal,
    inout vec4 ambient,
    inout vec4 diffuse,
    inout vec4 specular,
    in float zdir)
{
 
    // Normalized light direction and half vector
     vec3 thePosition=vec3(gl_LightSource[0].position);
    thePosition.x*=zdir;
    thePosition.y*=zdir;
     thePosition.z*=zdir;
    vec3 lightDirection = normalize(vec3(thePosition));
    
    vec3 halfVector =  vec3(gl_LightSource[0].halfVector);
    halfVector.x*=zdir;
    halfVector.y*=zdir;
    halfVector.z*=zdir;
    halfVector = normalize(halfVector);
    
    float nDotVP; // normal . light_direction
    float nDotHV; // normal . light_half_vector
    float pf; // power factor

    nDotVP = max(0.0, dot(normal, lightDirection));
    nDotHV = max(0.0, dot(normal, halfVector));

    if (nDotVP == 0.0) {
	pf = 0.0;
    }
    else {
	pf = pow(nDotHV, gl_FrontMaterial.shininess);
    }

    ambient += gl_LightSource[0].ambient;
    diffuse += gl_LightSource[0].diffuse * nDotVP;
    specular += gl_LightSource[0].specular * pf;
}


void main (void)
{

   

    vec4 amb =  vec4(0.0);
    vec4 diff =  vec4(0.0);
    vec4 spec =  vec4(0.0);
    
 
    
     directionalLight0(Normal,  amb, diff, spec,1.);
     directionalLight0(Normal,  amb, diff, spec,-1.);
    
    vec2 tc=gl_TexCoord[0].st;
 
     vec4 envColor=vec4(texture2D(theTex,tc));
     
       vec4 color2 = vec4(vec3(amb * envColor +diff * envColor ),1.0) ;
     
     color2.w=gl_FrontMaterial.diffuse.w;
   
      gl_FragColor =color2;
      
}
